using System;
using System.Collections.Generic;
using System.Xml.Serialization;

namespace RGD.MdsAPI.WMS
{
    public class getFreeLocNum : PlatformBase
    {
        /// <summary>入参定义
        /// 入参定义
        /// </summary>
        [Serializable]
        public class PARA : Base.InPara
        {
            private string _wh_id;

            //private string _oper_no;

            public string WH_ID
            {
                get { return this._wh_id; }
                set { this._wh_id = value; }
            }

            //public string OPER_NO
            //{
            //    get { return this._oper_no; }
            //    set { this._oper_no = value; }
            //}
        }

        /// <summary>出参定义
        /// 出参定义
        /// </summary>
        [Serializable]
        public class DATA : Base.OutPara
        {
            private List<LANE> _lane_list;

            /// <summary>
            /// 任务号
            /// </summary>
            [XmlArrayItem(ElementName = "LANE_LIST")]
            public List<LANE> LANE_LIST
            {
                get { return this._lane_list; }
                set { this._lane_list = value; }
            }
        }

        /// <summary>入参实体
        /// 入参实体
        /// </summary>
        private PARA _inPara;

        /// <summary>出参实体
        /// 出参实体
        /// </summary>
        private DATA _outPara;

        public getFreeLocNum()
        {
            this._inPara = new PARA();
        }

        /// <summary>通知
        /// 通知
        /// </summary>
        /// <param name="IO_TASK_NO">任务单号</param>
        /// <param name="ePLAN_STATUS">任务状态</param>
        /// <param name="sResult">返回结果</param>
        /// <returns></returns>
        public bool Notify(out string sResult)
        {
            bool bResult = true;

            sResult = string.Empty;

            string sXmlOut = string.Empty;

            try
            {
                this._inPara.WH_ID = GetWarehouseIndex();

                //this._inPara.OPER_NO = GetOperNo();

                string sXmlIn = this.Serializer<PARA>(this._inPara);

                bResult = this.getFreeLocNum(sXmlIn, out sXmlOut);

                //调用服务成功
                if (bResult)
                {
                    this._outPara = this.DeSerialize<DATA>(sXmlOut);

                    bResult = this._outPara.RESULT_FLAG.Equals(Enum.RESULT_FLAG.Success.ToString("d"));

                    sResult = sXmlOut;
                }

                return bResult;
            }
            catch (Exception ex)
            {
                bResult = false;

                sResult = string.Format(ex.Message);
            }

            return bResult;
        }
    }
}